package besysMonitor;

public class ProducerConsumer {

    public static void main(String[] args) {

        int initialFill = 5;
        int prodDelay = 400; 
        int consDelay = 400; 

        if (args.length > 0){
	    initialFill = Integer.parseInt(args[0]); 
	}
        if (args.length > 1){
	    prodDelay = Integer.parseInt(args[1]); 
	}
        if (args.length > 2){
	    consDelay = Integer.parseInt(args[2]); 
	}

	ProdConsBuffer buffer = new ProdConsBuffer(initialFill);
	Producer prod1 = new Producer(buffer, prodDelay);
	Consumer cons1 = new Consumer(buffer, consDelay);

        Producer prod2 = new Producer(buffer, prodDelay);
	Consumer cons2 = new Consumer(buffer, consDelay);
		
	prod1.start();
	cons1.start();

	prod2.start();
	cons2.start();
		
	return; 
    }

}
