
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h> 
#include <sys/stat.h> 
#include <sys/wait.h>

#include "fifodef.h" 

/********************************************
 * Achtung: Dieses Demo-Programm prüft die  *
 * Rückgabewerte der Systemaufrufe nicht.   *
 * In einem ernsthaft genutzten Programm    *
 * müssen die Rückgabewerte geprüft werden. *
 ********************************************/

void readFromFifo(FILE *stream){
  char msg[100]; 
  char *msgPtr; 
  char action = 'l';

  while (action != 'q'){
     msgPtr = fgets(msg, 100, stream); 
     printf("\n got msg: %s", msg);
     fflush(stdout);
     printf("\n lesen (l) abbrechen (q)");
     scanf(" %c", &action); 
  }  
  return;
}

int main(void){
    int fd;
    FILE *stream; 

    mode_t modus = S_IWUSR | S_IRUSR | S_IRGRP; 
    int res = unlink(fifoPath); 
    res = mkfifo(fifoPath, modus); 

    fd = open(fifoPath, O_RDWR);
    
    stream = fdopen(fd,"r");

    readFromFifo(stream);

    fclose(stream);
    res = unlink(fifoPath); 
     
    return 0;
}
