#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/wait.h>
#include <string.h>


void childFunction(int test_pipe[]){
  FILE *pipeStream;
  int i = 0; 
  char msg[100];
  char *msgPtr;

  close(test_pipe[1]);
  pipeStream = fdopen(test_pipe[0], "r");

  while (i < 10){
      /* sleepVal = sleep(1); */
    msgPtr = fgets(msg, 100, pipeStream);
    printf("\n child got message: %s", msg);
    i++;
  }
  printf("\n exit child process \n");
  exit(0);
}


void parentFunction(int test_pipe[], int pid){
  FILE *pipeStream;
  int i = 65; 
  int sleepVal;
  pid_t waitVal = 0;
  char msg[] = " new message:    \n";  /* Achtung: \n nicht vergessen */

  close(test_pipe[0]);
  pipeStream = fdopen(test_pipe[1], "w");

  fputs(msg, pipeStream);
  fputs(msg, pipeStream);

  while (waitVal == 0){ 
     msg[14] = i++; 
     fputs(msg, pipeStream);
     fflush(pipeStream); 
     waitVal = waitpid(pid, NULL, WNOHANG);
     sleepVal = sleep(1);
  }  
  return;
}










int main(void){
  pid_t pid;
 
  int test_pipe[2];

  if( pipe(test_pipe) != 0){
      printf("\n could not create pipe"); 
  }

  pid = fork();
  if (pid == 0){
    childFunction(test_pipe);
  }
  if (pid > 0){
    parentFunction(test_pipe, pid);
  }
  if (pid < 0){
    printf("\n P: could not create process "); 
  }

  return 0;
}

/*

*/
