package besys;

public class Producer extends Thread{
	int item; 
	Semaphore mutex;
	Semaphore full;
	Semaphore empty;
	ItemBuffer itemBuffer; 
	
	public Producer(){	
	}
	
	public Producer(Semaphore mutex_, 
			Semaphore full_, 
			Semaphore empty_,
			ItemBuffer itemBuffer_){
		mutex = mutex_;
		full  = full_;
		empty = empty_;
		itemBuffer = itemBuffer_; 
	}
	
	public void run(){
		int item;
		while(true){
			produceItem();
			sleepAmoment(350);
		}
	}
	
	
	void produceItem(){
		item = (int) Math.round(Math.random() * 10000);
		System.out.print("Producer: item " + Integer.toString(item));
		mutex.down(); 
                System.out.println(" got mutex ");  
		empty.down();
		itemBuffer.insertItem(item);
		mutex.up();
		full.up();
		System.out.println(" ... inserted"); 
	}
	
	void sleepAmoment(int time){
		int rand = (int) Math.round(300 * Math.random());
		try {
			this.sleep(time + rand);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	
}
