package besys;

public class Consumer extends Thread{
	int item; 
	Semaphore mutex;
	Semaphore full;
	Semaphore empty;
	ItemBuffer itemBuffer; 
	
	public Consumer(Semaphore mutex_, 
			Semaphore full_, 
			Semaphore empty_,
			ItemBuffer itemBuffer_){
		mutex = mutex_;
		full  = full_;
		empty = empty_;
		itemBuffer = itemBuffer_; 
	}
	
	public void run(){
		int item;
		while(true){
			consumeItem();
			sleepAmoment(400);
		}
	}
	
	
	private void consumeItem(){
		int item; 
		System.out.print("Consumer getting Item ... "); 
		full.down();
		mutex.down();
		item = itemBuffer.getItem();
		mutex.up();
		empty.up();
		consumeItem(item);
	}
	
	private void consumeItem(int item){
		System.out.println("Consuming Item: " + Integer.toString(item));
	}
	
	void sleepAmoment(int time){
		int rand = (int) Math.round(400 * Math.random());
		try {
			sleep(time + rand);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	
}
