#include <stdio.h>

float foo(int num, char msg[]){
    printf("\n foo(): %4d, %s", num, msg);
    return 1.1;
}

float bar(int num, char msg[]){
    num = -num;
    printf("\n bar(): %4d, %s", num, msg);
    return 2.2;
}

float fooBar(int num, char msg[]){
    num = num * num; 
    printf("\n fooBar(): %4d, %s", num, msg);
    return 3.3;
}

float barFoo(int num, char msg[]){
    num = num % 23; 
    printf("\n barFoo(): %4d, %s", num, msg);
    return 4.4;
}

/* note the place of the newly defined name */
typedef float FUNCTION (int, char []); 
typedef FUNCTION * FUNCTION_PTR; 
 
int main(void){
    int fnIndex = 0;
    float res = 0.0; 
    float (*testFunktion) (int, char []); 
   
    /* float (* myFunctions[4]) (int, char []); */ 

    FUNCTION_PTR myFunctions[4]; 

    myFunctions[0] = foo;
    myFunctions[1] = bar;
    myFunctions[2] = fooBar;
    myFunctions[3] = barFoo;

    testFunktion = fooBar;
    res = testFunktion(1234, "Test 1"); 
    printf("\n Result: %5.2f \n", res); 

    printf("\n Auswahl der Funktion (0-3):"); 
    scanf("%d", &fnIndex);

    res = myFunctions[fnIndex](1234, "Test"); 
    printf("\n Result: %5.2f \n", res); 
    
    return 0;
}



