package besysMonitor;

public class Consumer extends Thread {
	
    private ProdConsBuffer buffer = null;
    private int delay;

    public Consumer(ProdConsBuffer buffer, int delay){
	this.buffer = buffer;
        this.delay = delay; 
    }

    public void run(){
        int item;
        while(true){
            item = buffer.getItem();
            consumeItem(item);		
            sleepAmoment(delay); 
        }	
    }
	
    private void consumeItem(int item){
        // System.out.println("consumed: "+ Integer.toString(item));
        return;
    }
	
    void sleepAmoment(int time){
        int rand = (int) Math.round(500 * Math.random());
        try {
            this.sleep(time + rand);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        return;
    }
	
	
}
