package besysMonitor;

public class Producer extends Thread {
	
    private ProdConsBuffer buffer = null;
    private int delay; 
    private int count = 0;

    public Producer(ProdConsBuffer buffer, int delay){
        this.buffer = buffer; 
        this.delay = delay; 
    }

    public void run(){
	int item;
	while(true){
	    item = produceItem();
	    buffer.insert(item);
	    sleepAmoment(delay); 
	} 
    }
	
    int produceItem(){
        count = ++count % 99; 
	return count;
    }
	
    void sleepAmoment(int time){
	int rand = (int) Math.round(500 * Math.random());
	try {
	    this.sleep(time + rand);
	} catch (InterruptedException e) {
	    e.printStackTrace();
	}
    }


}

