
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h> 
#include <sys/stat.h> 
#include <sys/wait.h>

#include "fifodef.h"

/********************************************
 * Achtung: Dieses Demo-Programm prüft die  *
 * Rückgabewerte der Systemaufrufe nicht.   *
 * In einem ernsthaft genutzten Programm    *
 * müssen die Rückgabewerte geprüft werden. *
 ********************************************/

void writeInFifo(FILE *stream){
  const int length = 50; 
  char msg[length]; /* = " new message ...\n";  */ 
  msg[0] = ' '; 

  while (msg[0] != 'q'){ 
     printf("\n Nachricht oder abbrechen (q): ");
     fgets(msg, length, stdin); 
     fputs(msg, stream);
     fflush(stream);
  }  
  return;
}

int main(void){
    int fd;
    FILE *stream; 

    fd = open(fifoPath, O_RDWR);
    
    stream = fdopen(fd, "w");

    writeInFifo(stream);

    fclose(stream);

    return 0;
}
