#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/wait.h>
#include <string.h>


void childFunction(int test_pipe[1]){
  FILE *pipeStream;
  int i = 0; 
  char msg[100];
  char *msgPtr;
  int myPid = pid(); 

  close(test_pipe[1]);
  pipeStream = fdopen(test_pipe[0], "r");

  while (i < 10){
      /* sleepVal = sleep(1); */
    msgPtr = fgets(msg, 100, pipeStream);
    printf("\n child got message: %s", msg);
    i++;
  }
  printf("\n exit child process \n");
  exit(0);
}


void parentFunction(int test_pipe[2], int pid){
  FILE *pipeStream;
  int i = 65; 
  int sleepVal;
  pid_t waitVal = 0;
  char msg[] = " new message:    \n";  /* Achtung: \n nicht vergessen */

  close(test_pipe[0]);
  pipeStream = fdopen(test_pipe[1], "w");

  fputs(msg, pipeStream);
  fputs(msg, pipeStream);

  while (waitVal == 0){ 
     msg[14] = i++; 
     fputs(msg, pipeStream);
     fflush(pipeStream); 
     waitVal = waitpid(pid, NULL, WNOHANG);
     sleepVal = sleep(1);
  }  
  return;
}










int main(void){
  pid_t pid1;
  pid_t pid2;
  pid_t pid3;
 
  int test_pipe[2];

  if( pipe(test_pipe) != 0){
      printf("\n could not create pipe"); 
  }

  pid1 = fork();
  if (pid1 < 0){
    printf("\n P: could not create process "); 
    exit(-1);
  }
  if (pid1 == 0){
    childFunction(test_pipe);
  }

  /* if (pid1 > 0){ */
  pid2 = fork();
  if (pid2 < 0){
    printf("\n P: could not create process "); 
    exit(-1);
  }
  if (pid2 == 0){
    childFunction(test_pipe);
  }

  /* if (pid2 > 0){ */
  pid3 = fork();
  if (pid3 < 0){
    printf("\n P: could not create process "); 
    exit(-1);
  }
  if (pid3 == 0){
    childFunction(test_pipe);
  }

  parentFunction(test_pipe, pid3);
  
  return 0;
}

/*

*/
