#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/wait.h>
#include <string.h>


void childFunction(int test_pipe[2]){
  FILE *pipeInStream;
  FILE *pipeOutStream;
  int i = 0; 
  int test = 0; 
  char msg[100];
  char *msgPtr;


  pipeInStream = fdopen(test_pipe[0], "r");
  pipeOutStream = fdopen(test_pipe[1], "w");

  while (i < 10){
    sleep(1); 
    msgPtr = fgets(msg, 100, pipeInStream);
    sleep(1); 
    msg[5] -= 1;
    if (fputs(msg, pipeOutStream) < 0){
	printf("\n child could not write in pipe: %s", msg);
    }
    printf("\n child got message: %s", msg);
    i++;
  }
  printf("\n exit child process \n");
  exit(0);
}


void parentFunction(int test_pipe[2], int pid){
  FILE *pipeOutStream;
  FILE *pipeInStream;
  int i = 65; 
  int sleepVal;
  pid_t waitVal = 0;
  char msg[] = " new message:    \n";  /* Achtung: \n nicht vergessen */

  pipeOutStream = fdopen(test_pipe[1], "w");
  pipeInStream = fdopen(test_pipe[0], "r");

  fputs(msg, pipeOutStream);
  fputs(msg, pipeOutStream);

  while (waitVal == 0){ 
     msg[14] = i++; 
     fputs(msg, pipeOutStream);
     fflush(pipeOutStream); 
     waitVal = waitpid(pid, NULL, WNOHANG);
     sleepVal = sleep(1);
     /* 
     if (fgets(msg, 18, pipeInStream) == NULL){
	 printf("\n parent could not read from pipe"); 
     }
     */
  }  
  return;
}










int main(void){
  pid_t pid;
 
  int test_pipe[2];

  if( pipe(test_pipe) != 0){
      printf("\n could not create pipe"); 
  }

  pid = fork();
  if (pid == 0){
    childFunction(test_pipe);
  }
  if (pid > 0){
    parentFunction(test_pipe, pid);
  }
  if (pid < 0){
    printf("\n P: could not create process "); 
  }

  return 0;
}

/*

*/
