
#include <sys/wait.h> 
#include <sys/types.h>
#include <unistd.h> 
 
#include "msgkey.h"
/*

  in readMsg():
  First read messages of type stdType then read messages of any type 
*/

void readMsg(int queueID){
  MY_MSG myMessage; 
  ssize_t readCnt; 
  int rcvFlags = 0;
  myMessage.msgData[0] = ' ';
  myMessage.msgData[1] = 0;
  int counter = 0; 
  int sleepVal;
  int msgSize = sizeof(MY_MSG);

  while(counter < 5){
      readCnt = msgrcv(queueID, &myMessage, msgSize, stdType, rcvFlags);
      if (readCnt > 0){
	  printf("\n received: >>%s<< ", myMessage.msgData); 
          printf(" type: %d ", (int) myMessage.msgType); 
          printf(" from: %d ", myMessage.pid); 
      }
      sleepVal = sleep(2);
      counter++; 
  }
  while(counter < 20){
      readCnt = msgrcv(queueID, &myMessage, msgSize, 0, rcvFlags);
      if (readCnt > 0){
	  printf("\n received: >>%s<< ", myMessage.msgData); 
          printf(" type: %d ", (int) myMessage.msgType); 
          printf(" from: %d ", myMessage.pid); 
      }
      sleepVal = sleep(2);
      counter++; 
  }

  return;
}

int main(void){
  int closeRes;
  int queueId;
  int queueFlag = 432;   /* rw for user and group */ 
  queueFlag = queueFlag | IPC_CREAT;
  printf("\n Create-Flags: %d ", queueFlag);

  queueId = msgget(myMsgKey, queueFlag);
  if (queueId < 0){
    printf("\n could not create queue\n");
    exit(-1); 
  }

  readMsg(queueId);  

  closeRes = msgctl(queueId, IPC_RMID, NULL); 
  printf("\n closed queue %d, res: %d (0 is success)\n", queueId, closeRes); 

  return 0;
}

