#include <sys/types.h>
#include <unistd.h> 

#include "msgkey.h"

void sendMsg(int queueID){
  MY_MSG myMessage; 
  int sndFlags = 0; 
  int sendRes;
  int i = 0; 
  int msgSize = sizeof(MY_MSG);
  myMessage.msgType = 999; 
  strncpy(myMessage.msgData, "Nachricht Nr.                            ", dataSize);
  myMessage.msgData[dataSize - 2] = 'X'; 
  myMessage.msgData[dataSize - 1] = 0; 
  myMessage.pid = getpid(); 

  while (i < 10){
     myMessage.msgData[15] = i++ + '0'; 
     sendRes = msgsnd(queueID, &myMessage, msgSize, sndFlags); 
  }
  return;
}

int main(void){ 
  int closeRes;
  int queueId;
  int queueFlag = 432;   /* rw for user and group */ 
  queueFlag = 0; 
  printf("\n Create-Flags: %d ", queueFlag);
  
  queueId = msgget(myMsgKey, queueFlag);
  if (queueId < 0){
    printf("\n could not open queue %d \n", queueId);
    exit(-1); 
  }

  sendMsg(queueId); 

  printf("\n done sending messages to queue %d \n", queueId); 

  return 0;
} 
