package besys;

public class Semaphore {
    private int count = 1; 
	
    public Semaphore(){ 
    }
	
    public Semaphore(int initCount){
	if(initCount < 0){
	    System.out.println("Semaphore() init < 0");
	    initCount = 0; 
	}
	count = initCount;	
    }
	
    public synchronized void down(){
	while (count == 0){
	    semaphoreWait();
	}
	--count;
    }
	
    public synchronized void up(){
	++count;
	if (count == 1){
	    notify();
	}
    }

    private void semaphoreWait(){
	try {
	    wait();
	} catch (InterruptedException e) {
	    e.printStackTrace();
	}
    }
}
