package besys;

public class ProdConsMain { 
	
  public static void main(String[] args) {
     final  int capacity = 5; 
     ItemBuffer itemBuffer = new ItemBuffer(capacity);
     Semaphore mutex = new Semaphore(1); 
     Semaphore full = new Semaphore(0); 
     Semaphore empty = new Semaphore(capacity); 
     Producer producer1 = new Producer(mutex, full, empty, itemBuffer);
     Consumer consumer1 = new Consumer(mutex, full, empty, itemBuffer);
     Producer producer2 = new Producer(mutex, full, empty, itemBuffer);
     Consumer consumer2 = new Consumer(mutex, full, empty, itemBuffer);
     
     producer1.start();	
     consumer1.start();
     producer2.start();	
     consumer2.start();

  }
	
}
