package hrw.besys.socketServer;

import java.lang.Thread;
import java.net.Socket;
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.BufferedInputStream; 
import java.io.BufferedOutputStream; 


public class RequestHandler extends Thread {
    static int activeThreads = 0; 
    Socket aSocket; 
    InputStream inStream;
    OutputStream outStream;

    public RequestHandler(Socket _aSocket){
	aSocket = _aSocket;
    }

    public void run(){
	addToActiveThreads(1);
	try{
	    inStream  = new BufferedInputStream(aSocket.getInputStream());
	    outStream = new BufferedOutputStream(aSocket.getOutputStream()); 

	    int length = inStream.read();
	    int width  = inStream.read();
	    int result = length * width;

	    System.out.println("read length: " + Integer.toString(length)); 
	    System.out.println("read width: " + Integer.toString(width)); 
	    System.out.println("Active Threads: "  
                               + Integer.toString(activeThreads));

	    Thread.currentThread().sleep(5000); 

            outStream.write(result);
	    outStream.flush();

            System.out.println("returned result: " + Integer.toString(result)); 

            aSocket.close();
	}catch(Exception ex){
	     ex.printStackTrace();
	}

	addToActiveThreads(-1);

	return;
    }

    private synchronized void addToActiveThreads(int i){
	activeThreads = activeThreads + i;
	return;
    }

}

