
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>

const int threadNum = 5; 

struct threadArg{
    int number;
    char msg[30];
};
typedef struct threadArg THREAD_ARG;

void *thrFunction(void *thrParam){
    THREAD_ARG localValue;
    localValue = * (THREAD_ARG *)thrParam;
    sleep(localValue.number % 3);  
    printf("\n Thread no: %d", localValue.number);
    printf(", saying: %s", localValue.msg);
    fflush(stdout); 
    return NULL;
}


int main (void){
    THREAD_ARG *thrArg;
    int thrCnt;
    int result; 
    pthread_t threads[threadNum];

    for(thrCnt = 0; thrCnt < threadNum; thrCnt++){
	printf("\n creating a new thread . . . ");
	fflush(stdout);
	thrArg = (THREAD_ARG *) malloc(sizeof(THREAD_ARG)); 
	thrArg->number = thrCnt;
	strncpy(thrArg->msg, "Hello_", 29);
        thrArg->msg[6] = thrCnt + '0';
	thrArg->msg[7] = 0;
        
        result = pthread_create( &threads[thrCnt], 
                                 NULL, 
                                 thrFunction, 
                                 (void *) thrArg); 
	if (result != 0){
	    printf("\n  . . .error, pthread_create return code is: %d", result);
	}else{
	    printf(" . . .  thread created");
	}
    }
    fflush(stdout);
    sleep(3); 
    printf(" \n"); 

/*    pthread_exit(0); 
 */
    return 0;
}




